/* Copyright 2008-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

const char *s_mac_kernels = "                                                                               \n\
__kernel void mac_P0_kernel_4(int Nstate, int maxNpiece, int Nsc,                                           \n\
			      __global const float *QQ_eig,                                                 \n\
			      __global const float *QQ_eigvec,                                              \n\
			      __global const float *QQ_eiginv,                                              \n\
			      __global const int *seg_npiece,                                               \n\
			      __global const int *seg_piece_sc,                                             \n\
			      __global const float *seg_piece_dur,                                          \n\
			      __global       float *seg_piece_P0)                                           \n\
{                                                                                                           \n\
  __local float P0[4];                                                                                      \n\
  __local float Pt[4][4]; /* actual Pt[i] = sum(Pt[i,j]) */                                                 \n\
  __local float eigx[4];                                                                                    \n\
  __local float evec[4][4];                                                                                 \n\
  __local float einv[4][4];                                                                                 \n\
                                                                                                            \n\
  char i = (char) get_local_id(0);                                                                          \n\
  char j = (char) get_local_id(1);                                                                          \n\
  char k;                                                                                                   \n\
  short seg = (short) (get_global_id(0) / 4);                                                               \n\
  int sc, p;                                                                                                \n\
  int np = seg_npiece[seg] - 1; /* don't bother traversing final piece */                                   \n\
  float acc;                                                                                                \n\
                                                                                                            \n\
  if ( ! j )                                                                                                \n\
    P0[i] = seg_piece_P0[4*maxNpiece*seg + i];                                                              \n\
                                                                                                            \n\
  for (p=0; p<np; ++p) {                                                                                    \n\
    sc = seg_piece_sc[seg*maxNpiece + p];                                                                   \n\
    evec[i][j] = QQ_eigvec[sc*(4*4)+i*4+j];                                                                 \n\
    einv[i][j] = QQ_eiginv[sc*(4*4)+i*4+j];                                                                 \n\
    if ( ! j )                                                                                              \n\
      eigx[i] = (i < Nstate) ? (exp(seg_piece_dur[maxNpiece*seg + p] * QQ_eig[sc*4+i])) : 0.0f;             \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    acc = 0.0f;                                                                                             \n\
    for (k=Nstate-1; k>=0; --k)                                                                             \n\
      acc += P0[j] * evec[j][k] * eigx[k] * einv[k][i];                                                     \n\
    Pt[i][j] = acc;                                                                                         \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( ! j ) {                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += Pt[i][k];                                                                                    \n\
      P0[i] = acc;                                                                                          \n\
      seg_piece_P0[4*maxNpiece*seg + 4*(p+1) + i] = acc;                                                    \n\
    }                                                                                                       \n\
  }                                                                                                         \n\
}                                                                                                           \n\
                                                                                                            \n\
                                                                                                            \n\
"
"    /* mac sample: float time, cur, cur_var -*- fit, fit_var, rsv */                                        \n\
__kernel void mac_point_kernel_4(int Nstate, int maxNpiece, int Nsc, int Nchannel,                          \n\
				 __global const float *QQ_eig,                                              \n\
				 __global const float *QQ_eigvec,                                           \n\
				 __global const float *QQ_eiginv,                                           \n\
				 __global const int *seg_npiece,                                            \n\
				 __global const int *seg_piece_sc,                                          \n\
				 __global const float *seg_piece_dur,                                       \n\
				 __global const float *seg_piece_P0,                                        \n\
				 __global const float *seg_piece_dV,                                        \n\
				 __global const float *seg_piece_Ileak,                                     \n\
				 __global const float *xamp_,                                               \n\
				 __global const float *xvar_,                                               \n\
				 __global const int *work_items, /* seg, piece, offset_in_piece, count */   \n\
				 __global const float *samples,                                             \n\
				 __global       float *fit_var_ll_err,                                      \n\
				 float amp0, float var0,                                                    \n\
                              __global       float *dbg_out)                                                \n\
{                                                                                                           \n\
  __local float P0[4];                                                                                      \n\
  __local float Pt[4];                                                                                      \n\
  __local float varPt[4][4]; /* also temp Pt before summing rows */                                         \n\
  __local float eig[4];                                                                                     \n\
  __local float evec[4][4];                                                                                 \n\
  __local float einv[4][4];                                                                                 \n\
  __local float xamp[4];                                                                                    \n\
  __local float xvar[4];                                                                                    \n\
  __local float tmp[4][4];                                                                                  \n\
                                                                                                            \n\
  char i = (char) get_local_id(0);                                                                          \n\
  char j = (char) get_local_id(1);                                                                          \n\
  char k;                                                                                                   \n\
  int seg, p;                                                                                               \n\
                                                                                                            \n\
  int offset = get_global_id(0) / 4; /* temp. hold work_items index */                                      \n\
  p =  work_items[4*offset + 1];                                                                            \n\
  seg = work_items[4*offset + 0];                                                                           \n\
  int past_end = work_items[4*offset + 2] + work_items[4*offset + 3];                                       \n\
  offset = work_items[4*offset + 2];                                                                        \n\
                                                                                                            \n\
  int sc = seg_piece_sc[seg*maxNpiece + p];                                                                 \n\
  float dV = seg_piece_dV[seg*maxNpiece + p];                                                               \n\
  float Ileak = seg_piece_Ileak[seg*maxNpiece + p];                                                         \n\
  float acc, x, mean, var;                                                                                  \n\
                                                                                                            \n\
  evec[i][j] = QQ_eigvec[sc*(4*4)+i*4+j];                                                                   \n\
  einv[i][j] = QQ_eiginv[sc*(4*4)+i*4+j];                                                                   \n\
  if ( j == 0 ) {                                                                                           \n\
    P0[i] = seg_piece_P0[4*maxNpiece*seg + i];                                                              \n\
    eig[i] = QQ_eig[sc*4 + i];                                                                              \n\
    xamp[i] = xamp_[i];                                                                                     \n\
    xvar[i] = xvar_[i];                                                                                     \n\
  }                                                                                                         \n\
                                                                                                            \n\
  for (; offset < past_end; ++offset) {                                                                     \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    x = samples[3*offset + 0];                                                                              \n\
    tmp[i][j] = exp(x * eig[i]) * einv[i][j];                                                               \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    acc = 0.0f;                                                                                             \n\
    for (k=Nstate-1; k>=0; --k)                                                                             \n\
      acc += P0[j] * evec[j][k] * tmp[k][i];                                                                \n\
    varPt[i][j] = acc; /* actually Pt sub-sums */                                                           \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( ! j ) {                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += varPt[i][k];                                                                                 \n\
      Pt[i] = acc;                                                                                          \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == j )                                                                                           \n\
      varPt[i][j] = Pt[i] * (1.0f - Pt[i]);                                                                 \n\
    else                                                                                                    \n\
      varPt[i][j] = - Pt[i] * Pt[j];                                                                        \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( j == 0 ) {                                                                                         \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += xamp[k] * varPt[k][i];                                                                       \n\
      tmp[i][0] = acc;                                                                                      \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( (i == 0) && (j == 0) ) {                                                                           \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += Pt[k] * xamp[k];                                                                             \n\
      mean = acc * Nchannel * dV + Ileak + amp0;                                                            \n\
      fit_var_ll_err[4*offset    ] = mean;                                                                      \n\
                                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += xamp[k] * tmp[k][0] + Pt[k] * xvar[k];                                                       \n\
      var = acc * dV * dV * Nchannel + var0;                                                               \n\
      fit_var_ll_err[4*offset + 1] = var;                                                                       \n\
                                                                                                            \n\
      acc = samples[3*offset + 1] - mean;                                                                   \n\
      acc *= acc;                                                                                           \n\
      fit_var_ll_err[4*offset + 3] = sqrt(acc/var);                                                         \n\
      if ( var ) /* and useVar */                                                                           \n\
	fit_var_ll_err[4*offset + 2] = acc / var + log(var);                                                    \n\
      else                                                                                                  \n\
        fit_var_ll_err[4*offset + 2] = acc;                                                                     \n\
    }                                                                                                       \n\
  }                                                                                                         \n\
}                                                                                                           \n\
                                                                                                            \n\
"
"__kernel void mac_P0_kernel_8(int Nstate, int maxNpiece, int Nsc,                                           \n\
			      __global const float *QQ_eig,                                                 \n\
			      __global const float *QQ_eigvec,                                              \n\
			      __global const float *QQ_eiginv,                                              \n\
			      __global const int *seg_npiece,                                               \n\
			      __global const int *seg_piece_sc,                                             \n\
			      __global const float *seg_piece_dur,                                          \n\
			      __global       float *seg_piece_P0)                                           \n\
{                                                                                                           \n\
  __local float P0[8];                                                                                      \n\
  __local float Pt[8][8]; /* actual Pt[i] = sum(Pt[i,j]) */                                                 \n\
  __local float eigx[8];                                                                                    \n\
  __local float evec[8][8];                                                                                 \n\
  __local float einv[8][8];                                                                                 \n\
                                                                                                            \n\
  char i = (char) get_local_id(0);                                                                          \n\
  char j = (char) get_local_id(1);                                                                          \n\
  char k;                                                                                                   \n\
  int seg = get_global_id(0) / 8;                                                                           \n\
  int sc, p;                                                                                                \n\
  int np = seg_npiece[seg] - 1; /* don't bother traversing final piece */                                   \n\
  float acc;                                                                                                \n\
                                                                                                            \n\
  if ( ! j )                                                                                                \n\
    P0[i] = seg_piece_P0[8*maxNpiece*seg + i];                                                              \n\
                                                                                                            \n\
  for (p=0; p<np; ++p) {                                                                                    \n\
    sc = seg_piece_sc[seg*maxNpiece + p];                                                                   \n\
    evec[i][j] = QQ_eigvec[sc*(8*8)+i*8+j];                                                                 \n\
    einv[i][j] = QQ_eiginv[sc*(8*8)+i*8+j];                                                                 \n\
    if ( ! j )                                                                                              \n\
      eigx[i] = (i < Nstate) ? (exp(seg_piece_dur[maxNpiece*seg + p] * QQ_eig[sc*8+i])) : 0.0f;             \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    acc = 0.0f;                                                                                             \n\
    for (k=Nstate-1; k>=0; --k)                                                                             \n\
      acc += P0[j] * evec[j][k] * eigx[k] * einv[k][i];                                                     \n\
    Pt[i][j] = acc;                                                                                         \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( ! j ) {                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += Pt[i][k];                                                                                    \n\
      P0[i] = acc;                                                                                          \n\
      seg_piece_P0[8*maxNpiece*seg + 8*(p+1) + i] = acc;                                                    \n\
    }                                                                                                       \n\
  }                                                                                                         \n\
}                                                                                                           \n\
                                                                                                            \n\
                                                                                                            \n\
"
"__kernel void mac_point_kernel_8(int Nstate, int maxNpiece, int Nsc, int Nchannel,                          \n\
				 __global const float *QQ_eig,                                              \n\
				 __global const float *QQ_eigvec,                                           \n\
				 __global const float *QQ_eiginv,                                           \n\
				 __global const int *seg_npiece,                                            \n\
				 __global const int *seg_piece_sc,                                          \n\
				 __global const float *seg_piece_dur,                                       \n\
				 __global const float *seg_piece_P0,                                        \n\
				 __global const float *seg_piece_dV,                                        \n\
				 __global const float *seg_piece_Ileak,                                     \n\
				 __global const float *xamp_,                                               \n\
				 __global const float *xvar_,                                               \n\
				 __global const int *work_items, /* seg, piece, offset_in_piece, count */   \n\
				 __global const float *samples,                                             \n\
				 __global       float *fit_var_ll_err,                                      \n\
				 float amp0, float var0,                                                    \n\
                              __global       float *dbg_out)                                                \n\
{                                                                                                           \n\
  __local float P0[8];                                                                                      \n\
  __local float Pt[8];                                                                                      \n\
  __local float varPt[8][8]; /* also temp Pt before summing rows */                                         \n\
  __local float eig[8];                                                                                     \n\
  __local float evec[8][8];                                                                                 \n\
  __local float einv[8][8];                                                                                 \n\
  __local float xamp[8];                                                                                    \n\
  __local float xvar[8];                                                                                    \n\
  __local float tmp[8][8];                                                                                  \n\
                                                                                                            \n\
  char i = (char) get_local_id(0);                                                                          \n\
  char j = (char) get_local_id(1);                                                                          \n\
  char k;                                                                                                   \n\
  int seg, p;                                                                                               \n\
                                                                                                            \n\
  int offset = get_global_id(0) / 8; /* temp. hold work_items index */                                      \n\
  p = work_items[4*offset + 1];                                                                             \n\
  seg = work_items[4*offset + 0];                                                                           \n\
  int past_end = work_items[4*offset + 2] + work_items[4*offset + 3];                                       \n\
  offset = work_items[4*offset + 2];                                                                        \n\
                                                                                                            \n\
  int sc = seg_piece_sc[seg*maxNpiece + p];                                                                 \n\
  float dV = seg_piece_dV[seg*maxNpiece + p];                                                               \n\
  float Ileak = seg_piece_Ileak[seg*maxNpiece + p];                                                         \n\
  float acc, x, mean, var;                                                                                  \n\
                                                                                                            \n\
  evec[i][j] = QQ_eigvec[sc*(8*8)+i*8+j];                                                                   \n\
  einv[i][j] = QQ_eiginv[sc*(8*8)+i*8+j];                                                                   \n\
  if ( j == 0 ) {                                                                                           \n\
    P0[i] = seg_piece_P0[8*maxNpiece*seg + i];                                                              \n\
    eig[i] = QQ_eig[sc*8 + i];                                                                              \n\
    xamp[i] = xamp_[i];                                                                                     \n\
    xvar[i] = xvar_[i];                                                                                     \n\
  }                                                                                                         \n\
                                                                                                            \n\
  for (; offset < past_end; ++offset) {                                                                     \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    x = samples[3*offset + 0];                                                                              \n\
    tmp[i][j] = exp(x * eig[i]) * einv[i][j];                                                               \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    acc = 0.0f;                                                                                             \n\
    for (k=Nstate-1; k>=0; --k)                                                                             \n\
      acc += P0[j] * evec[j][k] * tmp[k][i];                                                                \n\
    varPt[i][j] = acc; /* actually Pt sub-sums */                                                           \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( ! j ) {                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += varPt[i][k];                                                                                 \n\
      Pt[i] = acc;                                                                                          \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == j )                                                                                           \n\
      varPt[i][j] = Pt[i] * (1.0f - Pt[i]);                                                                 \n\
    else                                                                                                    \n\
      varPt[i][j] = - Pt[i] * Pt[j];                                                                        \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( j == 0 ) {                                                                                         \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += xamp[k] * varPt[k][i];                                                                       \n\
      tmp[i][0] = acc;                                                                                      \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( (i == 0) && (j == 0) ) {                                                                           \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += Pt[k] * xamp[k];                                                                             \n\
      mean = acc * Nchannel * dV + Ileak + amp0;                                                            \n\
      fit_var_ll_err[4*offset    ] = mean;                                                                      \n\
                                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += xamp[k] * tmp[k][0] + Pt[k] * xvar[k];                                                       \n\
      var = acc * dV * dV * Nchannel + var0;                                                               \n\
      fit_var_ll_err[4*offset + 1] = var;                                                                       \n\
                                                                                                            \n\
      acc = samples[3*offset + 1] - mean;                                                                   \n\
      acc *= acc;                                                                                           \n\
      fit_var_ll_err[4*offset + 3] = sqrt(acc/var);                                                         \n\
      if ( var )                                                                                            \n\
	fit_var_ll_err[4*offset + 2] = acc / var + log(var);                                                    \n\
      else                                                                                                  \n\
        fit_var_ll_err[4*offset + 2] = acc;                                                                     \n\
    }                                                                                                       \n\
  }                                                                                                         \n\
}                                                                                                           \n\
                                                                                                            \n\
"
"__kernel void mac_P0_kernel_16(int Nstate, int maxNpiece, int Nsc,                                          \n\
			       __global const float *QQ_eig,                                                \n\
			       __global const float *QQ_eigvec,                                             \n\
			       __global const float *QQ_eiginv,                                             \n\
			       __global const int *seg_npiece,                                              \n\
			       __global const int *seg_piece_sc,                                            \n\
			       __global const float *seg_piece_dur,                                         \n\
			       __global       float *seg_piece_P0)                                          \n\
{                                                                                                           \n\
  __local float P0[16];                                                                                     \n\
  __local float Pt[16][16]; /* actual Pt[i] = sum(Pt[i,j]) */                                               \n\
  __local float eigx[16];                                                                                   \n\
  __local float evec[16][16];                                                                               \n\
  __local float einv[16][16];                                                                               \n\
                                                                                                            \n\
  char i = (char) get_local_id(0);                                                                          \n\
  char j = (char) get_local_id(1);                                                                          \n\
  char k;                                                                                                   \n\
  int seg = get_global_id(0) / 16;                                                                          \n\
  int sc, p;                                                                                                \n\
  int np = seg_npiece[seg] - 1; /* don't bother traversing final piece */                                   \n\
  float acc;                                                                                                \n\
                                                                                                            \n\
  if ( ! j )                                                                                                \n\
    P0[i] = seg_piece_P0[16*maxNpiece*seg + i];                                                             \n\
                                                                                                            \n\
  for (p=0; p<np; ++p) {                                                                                    \n\
    sc = seg_piece_sc[seg*maxNpiece + p];                                                                   \n\
    evec[i][j] = QQ_eigvec[sc*(16*16)+i*16+j];                                                              \n\
    einv[i][j] = QQ_eiginv[sc*(16*16)+i*16+j];                                                              \n\
    if ( ! j )                                                                                              \n\
      eigx[i] = (i < Nstate) ? (exp(seg_piece_dur[maxNpiece*seg + p] * QQ_eig[sc*16+i])) : 0.0f;            \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    acc = 0.0f;                                                                                             \n\
    for (k=Nstate-1; k>=0; --k)                                                                             \n\
      acc += P0[j] * evec[j][k] * eigx[k] * einv[k][i];                                                     \n\
    Pt[i][j] = acc;                                                                                         \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( ! j ) {                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += Pt[i][k];                                                                                    \n\
      P0[i] = acc;                                                                                          \n\
      seg_piece_P0[16*maxNpiece*seg + 16*(p+1) + i] = acc;                                                  \n\
    }                                                                                                       \n\
  }                                                                                                         \n\
}                                                                                                           \n\
                                                                                                            \n\
                                                                                                            \n\
                                                                                                            \n\
"
"__kernel void mac_point_kernel_16(int Nstate, int maxNpiece, int Nsc, int Nchannel,                         \n\
				 __global const float *QQ_eig,                                              \n\
				 __global const float *QQ_eigvec,                                           \n\
				 __global const float *QQ_eiginv,                                           \n\
				 __global const int *seg_npiece,                                            \n\
				 __global const int *seg_piece_sc,                                          \n\
				 __global const float *seg_piece_dur,                                       \n\
				 __global const float *seg_piece_P0,                                        \n\
				 __global const float *seg_piece_dV,                                        \n\
				 __global const float *seg_piece_Ileak,                                     \n\
				 __global const float *xamp_,                                               \n\
				 __global const float *xvar_,                                               \n\
				 __global const int *work_items, /* seg, piece, offset_in_piece, count  */  \n\
				 __global const float *samples,                                             \n\
				 __global       float *fit_var_ll_err,                                      \n\
				 float amp0, float var0,                                                    \n\
                              __global       float *dbg_out)                                                \n\
{                                                                                                           \n\
  __local float P0[16];                                                                                     \n\
  __local float Pt[16];                                                                                     \n\
  __local float varPt[16][16]; /* also temp Pt before summing rows  */                                      \n\
  __local float eig[16];                                                                                    \n\
  __local float evec[16][16];                                                                               \n\
  __local float einv[16][16];                                                                               \n\
  __local float xamp[16];                                                                                   \n\
  __local float xvar[16];                                                                                   \n\
  __local float tmp[16][16];                                                                                \n\
                                                                                                            \n\
  char i = (char) get_local_id(0);                                                                          \n\
  char j = (char) get_local_id(1);                                                                          \n\
  char k;                                                                                                   \n\
  int seg, p;                                                                                               \n\
                                                                                                            \n\
  int offset = get_global_id(0) / 16; /* temp. hold work_items index  */                                    \n\
  p = work_items[4*offset + 1];                                                                             \n\
  seg = work_items[4*offset + 0];                                                                           \n\
  int past_end = work_items[4*offset + 2] + work_items[4*offset + 3];                                       \n\
  offset = work_items[4*offset + 2];                                                                        \n\
                                                                                                            \n\
  int sc = seg_piece_sc[seg*maxNpiece + p];                                                                 \n\
  float dV = seg_piece_dV[seg*maxNpiece + p];                                                               \n\
  float Ileak = seg_piece_Ileak[seg*maxNpiece + p];                                                         \n\
  float acc, x, mean, var;                                                                                  \n\
                                                                                                            \n\
  evec[i][j] = QQ_eigvec[sc*(16*16)+i*16+j];                                                                \n\
  einv[i][j] = QQ_eiginv[sc*(16*16)+i*16+j];                                                                \n\
  if ( j == 0 ) {                                                                                           \n\
    P0[i] = seg_piece_P0[16*maxNpiece*seg + i];                                                             \n\
    eig[i] = QQ_eig[sc*16 + i];                                                                             \n\
    xamp[i] = xamp_[i];                                                                                     \n\
    xvar[i] = xvar_[i];                                                                                     \n\
  }                                                                                                         \n\
                                                                                                            \n\
  for (; offset < past_end; ++offset) {                                                                     \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    x = samples[3*offset + 0];                                                                              \n\
    tmp[i][j] = exp(x * eig[i]) * einv[i][j];                                                               \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    acc = 0.0f;                                                                                             \n\
    for (k=Nstate-1; k>=0; --k)                                                                             \n\
      acc += P0[j] * evec[j][k] * tmp[k][i];                                                                \n\
    varPt[i][j] = acc; /* actually Pt sub-sums */                                                           \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( ! j ) {                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += varPt[i][k];                                                                                 \n\
      Pt[i] = acc;                                                                                          \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == j )                                                                                           \n\
      varPt[i][j] = Pt[i] * (1.0f - Pt[i]);                                                                 \n\
    else                                                                                                    \n\
      varPt[i][j] = - Pt[i] * Pt[j];                                                                        \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( j == 0 ) {                                                                                         \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += xamp[k] * varPt[k][i];                                                                       \n\
      tmp[i][0] = acc;                                                                                      \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( (i == 0) && (j == 0) ) {                                                                           \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += Pt[k] * xamp[k];                                                                             \n\
      mean = acc * Nchannel * dV + Ileak + amp0;                                                            \n\
      fit_var_ll_err[4*offset    ] = mean;                                                                      \n\
                                                                                                            \n\
      acc = 0.0f;                                                                                           \n\
      for (k=Nstate-1; k>=0; --k)                                                                           \n\
	acc += xamp[k] * tmp[k][0] + Pt[k] * xvar[k];                                                       \n\
      var = acc * dV * dV * Nchannel + var0;                                                               \n\
      fit_var_ll_err[4*offset + 1] = var;                                                                       \n\
                                                                                                            \n\
      acc = samples[3*offset + 1] - mean;                                                                   \n\
      acc *= acc;                                                                                           \n\
      fit_var_ll_err[4*offset + 3] = sqrt(acc/var);                                                         \n\
      if ( var )                                                                                            \n\
	fit_var_ll_err[4*offset + 2] = acc / var + log(var);                                                    \n\
      else                                                                                                  \n\
        fit_var_ll_err[4*offset + 2] = acc;                                                                     \n\
    }                                                                                                       \n\
  }                                                                                                         \n\
}                                                                                                           \n\
                                                                                                            \n\
";
