/* Copyright 2008-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */


/*
dc_al = aligned_length(int, Ndwells[iSeg]):
      = (nd / block) + ((nd % block) ? 1 : 0)  || block = 128 / sizeof(int)
      = (nd / 32) + ((nd % 32) ? 1 : 0)
      = 32 * ceil(nd / 32)
dimdim = 4*4
load Nstate, clazz
c = dwells[seg_off[iSeg] + dc_al + 0]
sc = dwells[seg_off[iSeg] + 2*dc_al + 0]
ak (col) = P0[iModel*Nseg*4 + iSeg*4 ...]
          (zeroed if c >= 0) and (clazz[i] != c)
ll = - log(scale(ak)):
           |   scale = 1.0 / sum(ak)
           |   ak *= scale
           |   return scale
for dwell k (excepting the last):
   adwell = DwellProbMatrix(c, sc, t=((float *) dwells)[seg_off[iSeg]]):
   |  eQaa_U_base = iModel*dim_Nsc*(dim+1)*2*dimdim
   |  eQaa_lambda_base = iModel*dim_Nsc*(dim+1)*dim
   |      = matrix(zeros)(dim,dim)
   |      if c >= 0:
   |         load eQaa_U[iModel][sc][c+1][0 and 1] as U, Ui (dimension N_c x N_c)
   |         load eQaa_lambda[iModel][sc][c+1], diagonal of Lambda = exp(t*lambda[i])
   |         adwell[b,b] = U*Lambda*Ui
   |      else:
   |         load eQaa_U[iModel][sc][0][0 and 1] as U, Ui (dim Nstate)
   |         load eQaa_lambda[iModel][sc][0], diagonal of Lambda = exp(t*lambda[i])
   |         adwell = U*Lambda*Ui
   ak *= adwell
   c = dwells[seg_off[iSeg] + dc_al + k+1
   if c >= 0:
      adead = Adead(sc, c):
      |  Adead_base = iModel*dim_Nsc*dimdim
      |     = Adead[iModel*dim_Nsc*dim*dim + sc*dim*dim ..]
      |     if c == None:
      |        pass
      |     elif c >= 0:
      |        zero columns not in class c
      |     else:
      |        zero columns in class -(c+1)
   else:
      adead = Adead(sc, None)
   ak *= adead
   ll -= log(scale(ak))
   sc = dwells[seg_off[iSeg] + 2*dc_al + k+1]
adwell = DwellProbMatrix(c, sc, durations[Nd-1])
if c >= 0:
   adead = Adead(sc, -(c+1)):
else:
   adead = Adead(sc, None)
ak *= adead
ll -= log(scale(ak)


*/

const char *s_msl_kernels = "                                                                               \n\
#if defined(cl_khr_fp64)  // Khronos extension available?                                                   \n\
  #pragma OPENCL EXTENSION cl_khr_fp64 : enable                                                             \n\
#elif defined(cl_amd_fp64)  // AMD extension available?                                                     \n\
  #pragma OPENCL EXTENSION cl_amd_fp64 : enable                                                             \n\
#endif                                                                                                      \n\
__kernel void msl_kernel_4(short Nseg, short Nmodel, short dim_Nsc,                                         \n\
                              __global const int *Ndwells,                                                  \n\
			      __global const int *seg_off,                                                  \n\
			      __global const int *dwells,                                                   \n\
			      __global const float *P0,                                                     \n\
			      __global       double *LL,                                                     \n\
			      __global const int *Ns,                                                       \n\
			      __global const int *clazz,                                                    \n\
                              __global const double *Adead,                                                  \n\
                              __global const double *eQaa_U,                                                 \n\
                              __global const double *eQaa_lambda)                                            \n\
{                                                                                                           \n\
    __local int states_of_class[4][4], Nstate_of_class[4];                                                  \n\
    __local int clz[4];                                                                                     \n\
    __local double p0[4], p1[4], p2[4];                                                                     \n\
    __local double AA[4][4];                                                                                \n\
    __local double U[4][4], Ui[4][4], Lambda[4];                                                            \n\
    __local float tdwt[4];                                                                                  \n\
    __local int idwt[4], sdwt[4];                                                                           \n\
    int dc_al, d;                                                                                           \n\
    double sum;                                                                                             \n\
    //short iSeg = (short) get_group_id(0);                                                                 \n\
    //short iModel = (short) get_group_id(1);                                                               \n\
    char i = (char) get_local_id(0);                                                                        \n\
    char j = (char) get_local_id(1);                                                                        \n\
    if ( i == 0 )                                                                                           \n\
        clz[j] = (char) clazz[4*get_group_id(1) + j];                                                       \n\
    char k;                                                                                                 \n\
    int eQ_base = get_group_id(1) * dim_Nsc * (4+1) * 2 * 4*4;                                              \n\
    int eQ_lambda_base = get_group_id(1) * dim_Nsc * (4+1) * 4;                                             \n\
    int Adead_base = get_group_id(1) * dim_Nsc * 4*4;                                                       \n\
    int Nstate = Ns[get_group_id(1)];                                                                       \n\
    int dwells_base = seg_off[get_group_id(0)];                                                             \n\
    int Ndwell = Ndwells[get_group_id(0)];                                                                  \n\
    dc_al = 32*((Ndwell / 32) + ((Ndwell % 32) ? 1 : 0));                                                   \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    char c, Ns_c = 0;                                                                                       \n\
    short sc;                                                                                               \n\
    float dur;                                                                                              \n\
    double ll = 0.0;                                                                                        \n\
    if ( i == 0 ) {                                                                                         \n\
        for (k=Nstate-1; k>=0; --k) {                                                                       \n\
            if ( clz[k] == j )                                                                              \n\
                states_of_class[j][Ns_c++] = k;                                                             \n\
        }                                                                                                   \n\
        Nstate_of_class[j] = Ns_c;                                                                          \n\
        // follow with out-of-class states, to permute full matrices                                        \n\
        for (k=4-1; k>=0; --k) {                                                                            \n\
            if ( clz[k] != j )                                                                              \n\
                states_of_class[j][Ns_c++] = k;                                                             \n\
        }                                                                                                   \n\
        tdwt[j] = ((__global float *) dwells)[dwells_base + j];                                             \n\
	idwt[j] = dwells[dwells_base + dc_al + j];                                                          \n\
	sdwt[j] = dwells[dwells_base + 2*dc_al + j];                                                        \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    c = (char) idwt[0];                                                                                     \n\
    sc = (short) sdwt[0];                                                                                   \n\
    dur = tdwt[0];                                                                                          \n\
    if ( i == 0 ) {                                                                                         \n\
        if ( (c >= 0) && (clz[j] != c) )                                                                    \n\
            p0[j] = 0.0;                                                                                    \n\
        else                                                                                                \n\
            p0[j] = P0[get_group_id(1)*dim_Nsc*4 + sc*4 + j];                                               \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( 0 == (i + j) ) {                                                                                   \n\
        sum = 0.0;                                                                                          \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += p0[k];                                                                                   \n\
        if ( sum )                                                                                          \n\
            sum = 1.0 / sum;                                                                                \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            p1[k] = p0[k] * sum;                                                                            \n\
    } else {                                                                                                \n\
        sum = 1.0;                                                                                          \n\
    }                                                                                                       \n\
    ll = log((float)sum);                                                                                   \n\
    d = 1;                                                                                                  \n\
"
"    do {                                                                                                    \n\
        sum = 0.0;                                                                                          \n\
        if ( c >= 0 ) {                                                                                     \n\
	    if ( i == 0 )                                                                                   \n\
                Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(4+1)*4 + (c+1)*4 + j];                         \n\
            U[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 + (c+1)*2*4*4        + 4*i + j];                      \n\
            Ui[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 + (c+1)*2*4*4 + 4*4 + 4*i + j];                      \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
            for (k=Nstate_of_class[c]-1; k>=0; --k)                                                         \n\
                sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                  \n\
            AA[ states_of_class[c][i] ][ states_of_class[c][j] ] = sum;                                     \n\
        } else {                                                                                            \n\
            if ( i == 0 )                                                                                   \n\
                Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(4+1)*4 + j];                                   \n\
            U[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 +      + 4*i + j];                                    \n\
            Ui[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 + 4*4 + 4*i + j];                                    \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                  \n\
            AA[i][j] = sum;                                                                                 \n\
        }                                                                                                   \n\
        if ( ! (i + (d%4)) ) { // both i and d%4 zero (neither can be negative)                             \n\
            tdwt[j] = ((__global float *) dwells)[dwells_base + d + j];                                     \n\
            idwt[j] = dwells[dwells_base + dc_al + d + j];                                                  \n\
            sdwt[j] = dwells[dwells_base + 2*dc_al + d + j];                                                \n\
        }                                                                                                   \n\
	sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( i == 0 ) {                                                                                     \n\
             for (k=Nstate-1; k>=0; --k)                                                                    \n\
                sum += p1[k] * AA[k][j];                                                                    \n\
            p2[j] = sum;                                                                                    \n\
        }                                                                                                   \n\
        c = (char) idwt[d%4];                                                                               \n\
        AA[i][j] = ((c < 0) || (c == clz[j])) ? Adead[Adead_base + sc*4*4 + i*4 + j] : 0.0;                 \n\
	sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( i == 0 ) {                                                                                     \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += p2[k] * AA[k][j];                                                                    \n\
            p0[j] = sum;                                                                                    \n\
        }                                                                                                   \n\
        sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( 0 == (i+j) ) {                                                                                 \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += p0[k];                                                                               \n\
            if ( sum )                                                                                      \n\
                sum = 1.0 / sum;                                                                            \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                p1[k] = p0[k] * sum;                                                                        \n\
        } else {                                                                                            \n\
            sum = 1.0;                                                                                      \n\
        }                                                                                                   \n\
        ll += log((float)sum);                                                                              \n\
	sc = (short) sdwt[d%4];                                                                             \n\
        dur = tdwt[d%4];                                                                                    \n\
        ++d;                                                                                                \n\
    } while ( d < Ndwell );                                                                                 \n\
                                                                                                            \n\
    sum = 0.0;                                                                                              \n\
    if ( c >= 0 ) {                                                                                         \n\
        if ( i == 0 )                                                                                       \n\
            Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(4+1)*4 + (c+1)*4 + j];                             \n\
        U[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 + (c+1)*2*4*4        + 4*i + j];                          \n\
        Ui[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 + (c+1)*2*4*4 + 4*4 + 4*i + j];                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        for (k=Nstate_of_class[c]-1; k>=0; --k)                                                             \n\
            sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                      \n\
        AA[ states_of_class[c][i] ][ states_of_class[c][j] ] = sum;                                         \n\
    } else {                                                                                                \n\
        if ( i == 0 )                                                                                       \n\
            Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(4+1)*4 + j];                                       \n\
        U[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 +      + 4*i + j];                                        \n\
        Ui[i][j] = eQaa_U[eQ_base + sc*(4+1)*2*4*4 + 4*4 + 4*i + j];                                        \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                      \n\
        AA[i][j] = sum;                                                                                     \n\
    }                                                                                                       \n\
sum = 0.0;                                                                                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == 0 ) {                                                                                         \n\
         for (k=Nstate-1; k>=0; --k)                                                                        \n\
            sum += p1[k] * AA[k][j];                                                                        \n\
        p2[j] = sum;                                                                                        \n\
    }                                                                                                       \n\
    AA[i][j] = ((c < 0) || (c != clz[j])) ? Adead[Adead_base + sc*4*4 + i*4 + j] : 0.0;                     \n\
sum = 0.0;                                                                                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == 0 ) {                                                                                         \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += p2[k] * AA[k][j];                                                                        \n\
        p0[j] = sum;                                                                                        \n\
    }                                                                                                       \n\
    sum = 0.0;                                                                                              \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( 0 == (i+j) ) {                                                                                     \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
        sum += p0[k];                                                                                       \n\
        if ( sum )                                                                                          \n\
            sum = 1.0 / sum;                                                                                \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            p1[k] = p0[k] * sum;                                                                            \n\
    } else {                                                                                                \n\
        sum = 1.0;                                                                                          \n\
    }                                                                                                       \n\
    ll += log((float)sum);                                                                                  \n\
                                                                                                            \n\
    if ( (i+j) == 0 )                                                                                       \n\
        LL[get_group_id(1)*Nseg + get_group_id(0)] = - ll;                                                  \n\
}                                                                                                           \n\
"
"                                                                                                            \n\
__kernel void msl_kernel_8(short Nseg, short Nmodel, short dim_Nsc,                                         \n\
                              __global const int *Ndwells,                                                  \n\
			      __global const int *seg_off,                                                  \n\
			      __global const int *dwells,                                                   \n\
			      __global const float *P0,                                                     \n\
			      __global       double *LL,                                                     \n\
			      __global const int *Ns,                                                       \n\
			      __global const int *clazz,                                                    \n\
                              __global const double *Adead,                                                  \n\
                              __global const double *eQaa_U,                                                 \n\
                              __global const double *eQaa_lambda)                                            \n\
{                                                                                                           \n\
    __local int states_of_class[8][8], Nstate_of_class[8];                                                  \n\
    __local int clz[8];                                                                                     \n\
    __local double p0[8], p1[8], p2[8];                                                                     \n\
    __local double AA[8][8];                                                                                \n\
    __local double U[8][8], Ui[8][8], Lambda[8];                                                            \n\
    __local float tdwt[8];                                                                                  \n\
    __local int idwt[8], sdwt[8];                                                                           \n\
    int dc_al, d;                                                                                           \n\
    double sum;                                                                                             \n\
    //short iSeg = (short) get_group_id(0);                                                                 \n\
    //short iModel = (short) get_group_id(1);                                                               \n\
    char i = (char) get_local_id(0);                                                                        \n\
    char j = (char) get_local_id(1);                                                                        \n\
    if ( i == 0 )                                                                                           \n\
        clz[j] = (char) clazz[8*get_group_id(1) + j];                                                       \n\
    char k;                                                                                                 \n\
    int eQ_base = get_group_id(1) * dim_Nsc * (8+1) * 2 * 8*8;                                              \n\
    int eQ_lambda_base = get_group_id(1) * dim_Nsc * (8+1) * 8;                                             \n\
    int Adead_base = get_group_id(1) * dim_Nsc * 8*8;                                                       \n\
    int Nstate = Ns[get_group_id(1)];                                                                       \n\
    int dwells_base = seg_off[get_group_id(0)];                                                             \n\
    int Ndwell = Ndwells[get_group_id(0)];                                                                  \n\
    dc_al = 32*((Ndwell / 32) + ((Ndwell % 32) ? 1 : 0));                                                   \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    char c, Ns_c = 0;                                                                                       \n\
    short sc;                                                                                               \n\
    float dur;                                                                                              \n\
    double ll = 0.0;                                                                                        \n\
    if ( i == 0 ) {                                                                                         \n\
        for (k=Nstate-1; k>=0; --k) {                                                                       \n\
            if ( clz[k] == j )                                                                              \n\
                states_of_class[j][Ns_c++] = k;                                                             \n\
        }                                                                                                   \n\
        Nstate_of_class[j] = Ns_c;                                                                          \n\
        // follow with out-of-class states, to permute full matrices                                        \n\
        for (k=8-1; k>=0; --k) {                                                                            \n\
            if ( clz[k] != j )                                                                              \n\
                states_of_class[j][Ns_c++] = k;                                                             \n\
        }                                                                                                   \n\
        tdwt[j] = ((__global float *) dwells)[dwells_base + j];                                             \n\
	idwt[j] = dwells[dwells_base + dc_al + j];                                                          \n\
	sdwt[j] = dwells[dwells_base + 2*dc_al + j];                                                        \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    c = (char) idwt[0];                                                                                     \n\
    sc = (short) sdwt[0];                                                                                   \n\
    dur = tdwt[0];                                                                                          \n\
    if ( i == 0 ) {                                                                                         \n\
        if ( (c >= 0) && (clz[j] != c) )                                                                    \n\
            p0[j] = 0.0;                                                                                    \n\
        else                                                                                                \n\
            p0[j] = P0[get_group_id(1)*dim_Nsc*8 + sc*8 + j];                                               \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( 0 == (i + j) ) {                                                                                   \n\
        sum = 0.0;                                                                                          \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += p0[k];                                                                                   \n\
        if ( sum )                                                                                          \n\
            sum = 1.0 / sum;                                                                                \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            p1[k] = p0[k] * sum;                                                                            \n\
    } else {                                                                                                \n\
        sum = 1.0;                                                                                          \n\
    }                                                                                                       \n\
    ll = log((float)sum);                                                                                   \n\
    d = 1;                                                                                                  \n\
"
"    do {                                                                                                    \n\
        sum = 0.0;                                                                                          \n\
        if ( c >= 0 ) {                                                                                     \n\
	    if ( i == 0 )                                                                                   \n\
                Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(8+1)*8 + (c+1)*8 + j];                         \n\
            U[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 + (c+1)*2*8*8        + 8*i + j];                      \n\
            Ui[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 + (c+1)*2*8*8 + 8*8 + 8*i + j];                      \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
            for (k=Nstate_of_class[c]-1; k>=0; --k)                                                         \n\
                sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                  \n\
            AA[ states_of_class[c][i] ][ states_of_class[c][j] ] = sum;                                     \n\
        } else {                                                                                            \n\
            if ( i == 0 )                                                                                   \n\
                Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(8+1)*8 + j];                                   \n\
            U[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 +      + 8*i + j];                                    \n\
            Ui[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 + 8*8 + 8*i + j];                                    \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                  \n\
            AA[i][j] = sum;                                                                                 \n\
        }                                                                                                   \n\
        if ( ! (i + (d%8)) ) { // both i and d%8 zero (neither can be negative)                             \n\
            tdwt[j] = ((__global float *) dwells)[dwells_base + d + j];                                     \n\
            idwt[j] = dwells[dwells_base + dc_al + d + j];                                                  \n\
            sdwt[j] = dwells[dwells_base + 2*dc_al + d + j];                                                \n\
        }                                                                                                   \n\
	sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( i == 0 ) {                                                                                     \n\
             for (k=Nstate-1; k>=0; --k)                                                                    \n\
                sum += p1[k] * AA[k][j];                                                                    \n\
            p2[j] = sum;                                                                                    \n\
        }                                                                                                   \n\
        c = (char) idwt[d%8];                                                                               \n\
        AA[i][j] = ((c < 0) || (c == clz[j])) ? Adead[Adead_base + sc*8*8 + i*8 + j] : 0.0;                 \n\
	sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( i == 0 ) {                                                                                     \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += p2[k] * AA[k][j];                                                                    \n\
            p0[j] = sum;                                                                                    \n\
        }                                                                                                   \n\
        sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( 0 == (i+j) ) {                                                                                 \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += p0[k];                                                                               \n\
            if ( sum )                                                                                      \n\
                sum = 1.0 / sum;                                                                            \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                p1[k] = p0[k] * sum;                                                                        \n\
        } else {                                                                                            \n\
            sum = 1.0;                                                                                      \n\
        }                                                                                                   \n\
        ll += log((float)sum);                                                                              \n\
	sc = (short) sdwt[d%8];                                                                             \n\
        dur = tdwt[d%8];                                                                                    \n\
        ++d;                                                                                                \n\
    } while ( d < Ndwell );                                                                                 \n\
                                                                                                            \n\
    sum = 0.0;                                                                                              \n\
    if ( c >= 0 ) {                                                                                         \n\
        if ( i == 0 )                                                                                       \n\
            Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(8+1)*8 + (c+1)*8 + j];                             \n\
        U[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 + (c+1)*2*8*8        + 8*i + j];                          \n\
        Ui[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 + (c+1)*2*8*8 + 8*8 + 8*i + j];                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        for (k=Nstate_of_class[c]-1; k>=0; --k)                                                             \n\
            sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                      \n\
        AA[ states_of_class[c][i] ][ states_of_class[c][j] ] = sum;                                         \n\
    } else {                                                                                                \n\
        if ( i == 0 )                                                                                       \n\
            Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(8+1)*8 + j];                                       \n\
        U[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 +      + 8*i + j];                                        \n\
        Ui[i][j] = eQaa_U[eQ_base + sc*(8+1)*2*8*8 + 8*8 + 8*i + j];                                        \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                      \n\
        AA[i][j] = sum;                                                                                     \n\
    }                                                                                                       \n\
sum = 0.0;                                                                                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == 0 ) {                                                                                         \n\
         for (k=Nstate-1; k>=0; --k)                                                                        \n\
            sum += p1[k] * AA[k][j];                                                                        \n\
        p2[j] = sum;                                                                                        \n\
    }                                                                                                       \n\
    AA[i][j] = ((c < 0) || (c != clz[j])) ? Adead[Adead_base + sc*8*8 + i*8 + j] : 0.0;                     \n\
sum = 0.0;                                                                                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == 0 ) {                                                                                         \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += p2[k] * AA[k][j];                                                                        \n\
        p0[j] = sum;                                                                                        \n\
    }                                                                                                       \n\
    sum = 0.0;                                                                                              \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( 0 == (i+j) ) {                                                                                     \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
        sum += p0[k];                                                                                       \n\
        if ( sum )                                                                                          \n\
            sum = 1.0 / sum;                                                                                \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            p1[k] = p0[k] * sum;                                                                            \n\
    } else {                                                                                                \n\
        sum = 1.0;                                                                                          \n\
    }                                                                                                       \n\
    ll += log((float)sum);                                                                                  \n\
                                                                                                            \n\
    if ( (i+j) == 0 )                                                                                       \n\
        LL[get_group_id(1)*Nseg + get_group_id(0)] = - ll;                                                  \n\
}                                                                                                           \n\
                                                                                                            \n\
"
"__kernel void msl_kernel_16(short Nseg, short Nmodel, short dim_Nsc,                                        \n\
                              __global const int *Ndwells,                                                  \n\
			      __global const int *seg_off,                                                  \n\
			      __global const int *dwells,                                                   \n\
			      __global const float *P0,                                                     \n\
			      __global       double *LL,                                                     \n\
			      __global const int *Ns,                                                       \n\
			      __global const int *clazz,                                                    \n\
                              __global const double *Adead,                                                  \n\
                              __global const double *eQaa_U,                                                 \n\
                              __global const double *eQaa_lambda)                                            \n\
{                                                                                                           \n\
    __local int states_of_class[16][16], Nstate_of_class[16];                                               \n\
    __local int clz[16];                                                                                    \n\
    __local double p0[16], p1[16], p2[16];                                                                  \n\
    __local double AA[16][16];                                                                              \n\
    __local double U[16][16], Ui[16][16], Lambda[16];                                                       \n\
    __local float tdwt[16];                                                                                 \n\
    __local int idwt[16], sdwt[16];                                                                         \n\
    int dc_al, d;                                                                                           \n\
    double sum;                                                                                             \n\
    //short iSeg = (short) get_group_id(0);                                                                 \n\
    //short iModel = (short) get_group_id(1);                                                               \n\
    char i = (char) get_local_id(0);                                                                        \n\
    char j = (char) get_local_id(1);                                                                        \n\
    if ( i == 0 )                                                                                           \n\
        clz[j] = (char) clazz[16*get_group_id(1) + j];                                                      \n\
    char k;                                                                                                 \n\
    int eQ_base = get_group_id(1) * dim_Nsc * (16+1) * 2 * 16*16;                                           \n\
    int eQ_lambda_base = get_group_id(1) * dim_Nsc * (16+1) * 16;                                           \n\
    int Adead_base = get_group_id(1) * dim_Nsc * 16*16;                                                     \n\
    int Nstate = Ns[get_group_id(1)];                                                                       \n\
    int dwells_base = seg_off[get_group_id(0)];                                                             \n\
    int Ndwell = Ndwells[get_group_id(0)];                                                                  \n\
    dc_al = 32*((Ndwell / 32) + ((Ndwell % 32) ? 1 : 0));                                                   \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    char c, Ns_c = 0;                                                                                       \n\
    short sc;                                                                                               \n\
    float dur;                                                                                              \n\
    double ll = 0.0;                                                                                        \n\
    if ( i == 0 ) {                                                                                         \n\
        for (k=Nstate-1; k>=0; --k) {                                                                       \n\
            if ( clz[k] == j )                                                                              \n\
                states_of_class[j][Ns_c++] = k;                                                             \n\
        }                                                                                                   \n\
        Nstate_of_class[j] = Ns_c;                                                                          \n\
        // follow with out-of-class states, to permute full matrices                                        \n\
        for (k=16-1; k>=0; --k) {                                                                           \n\
            if ( clz[k] != j )                                                                              \n\
                states_of_class[j][Ns_c++] = k;                                                             \n\
        }                                                                                                   \n\
        tdwt[j] = ((__global float *) dwells)[dwells_base + j];                                             \n\
	idwt[j] = dwells[dwells_base + dc_al + j];                                                          \n\
	sdwt[j] = dwells[dwells_base + 2*dc_al + j];                                                        \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    c = (char) idwt[0];                                                                                     \n\
    sc = (short) sdwt[0];                                                                                   \n\
    dur = tdwt[0];                                                                                          \n\
    if ( i == 0 ) {                                                                                         \n\
        if ( (c >= 0) && (clz[j] != c) )                                                                    \n\
            p0[j] = 0.0;                                                                                    \n\
        else                                                                                                \n\
            p0[j] = P0[get_group_id(1)*dim_Nsc*16 + sc*16 + j];                                             \n\
    }                                                                                                       \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( 0 == (i + j) ) {                                                                                   \n\
        sum = 0.0;                                                                                          \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += p0[k];                                                                                   \n\
        if ( sum )                                                                                          \n\
            sum = 1.0 / sum;                                                                                \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            p1[k] = p0[k] * sum;                                                                            \n\
    } else {                                                                                                \n\
        sum = 1.0;                                                                                          \n\
    }                                                                                                       \n\
    ll = log((float)sum);                                                                                   \n\
    d = 1;                                                                                                  \n\
"
"    do {                                                                                                    \n\
        sum = 0.0;                                                                                          \n\
        if ( c >= 0 ) {                                                                                     \n\
	    if ( i == 0 )                                                                                   \n\
                Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(16+1)*16 + (c+1)*16 + j];                      \n\
            U[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 + (c+1)*2*16*16        + 16*i + j];                \n\
            Ui[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 + (c+1)*2*16*16 + 16*16 + 16*i + j];              \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
            for (k=Nstate_of_class[c]-1; k>=0; --k)                                                         \n\
                sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                  \n\
            AA[ states_of_class[c][i] ][ states_of_class[c][j] ] = sum;                                     \n\
        } else {                                                                                            \n\
            if ( i == 0 )                                                                                   \n\
                Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(16+1)*16 + j];                                 \n\
            U[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 +      + 16*i + j];                                \n\
            Ui[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 + 16*16 + 16*i + j];                              \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                  \n\
            AA[i][j] = sum;                                                                                 \n\
        }                                                                                                   \n\
        if ( ! (i + (d%16)) ) { // both i and d%16 zero (neither can be negative)                           \n\
            tdwt[j] = ((__global float *) dwells)[dwells_base + d + j];                                     \n\
            idwt[j] = dwells[dwells_base + dc_al + d + j];                                                  \n\
            sdwt[j] = dwells[dwells_base + 2*dc_al + d + j];                                                \n\
        }                                                                                                   \n\
	sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( i == 0 ) {                                                                                     \n\
             for (k=Nstate-1; k>=0; --k)                                                                    \n\
                sum += p1[k] * AA[k][j];                                                                    \n\
            p2[j] = sum;                                                                                    \n\
        }                                                                                                   \n\
        c = (char) idwt[d%16];                                                                              \n\
        AA[i][j] = ((c < 0) || (c == clz[j])) ? Adead[Adead_base + sc*16*16 + i*16 + j] : 0.0;              \n\
	sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( i == 0 ) {                                                                                     \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += p2[k] * AA[k][j];                                                                    \n\
            p0[j] = sum;                                                                                    \n\
        }                                                                                                   \n\
        sum = 0.0;                                                                                          \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        if ( 0 == (i+j) ) {                                                                                 \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                sum += p0[k];                                                                               \n\
            if ( sum )                                                                                      \n\
                sum = 1.0 / sum;                                                                            \n\
            for (k=Nstate-1; k>=0; --k)                                                                     \n\
                p1[k] = p0[k] * sum;                                                                        \n\
        } else {                                                                                            \n\
            sum = 1.0;                                                                                      \n\
        }                                                                                                   \n\
        ll += log((float)sum);                                                                              \n\
	sc = (short) sdwt[d%16];                                                                            \n\
        dur = tdwt[d%16];                                                                                   \n\
        ++d;                                                                                                \n\
    } while ( d < Ndwell );                                                                                 \n\
                                                                                                            \n\
    sum = 0.0;                                                                                              \n\
    if ( c >= 0 ) {                                                                                         \n\
        if ( i == 0 )                                                                                       \n\
            Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(16+1)*16 + (c+1)*16 + j];                          \n\
        U[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 + (c+1)*2*16*16        + 16*i + j];                    \n\
        Ui[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 + (c+1)*2*16*16 + 16*16 + 16*i + j];                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        for (k=Nstate_of_class[c]-1; k>=0; --k)                                                             \n\
            sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                      \n\
        AA[ states_of_class[c][i] ][ states_of_class[c][j] ] = sum;                                         \n\
    } else {                                                                                                \n\
        if ( i == 0 )                                                                                       \n\
            Lambda[j] = eQaa_lambda[eQ_lambda_base + sc*(16+1)*16 + j];                                     \n\
        U[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 +      + 16*i + j];                                    \n\
        Ui[i][j] = eQaa_U[eQ_base + sc*(16+1)*2*16*16 + 16*16 + 16*i + j];                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += U[i][k] * exp((float)(Lambda[k]) * dur) * Ui[k][j];                                      \n\
        AA[i][j] = sum;                                                                                     \n\
    }                                                                                                       \n\
sum = 0.0;                                                                                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == 0 ) {                                                                                         \n\
         for (k=Nstate-1; k>=0; --k)                                                                        \n\
            sum += p1[k] * AA[k][j];                                                                        \n\
        p2[j] = sum;                                                                                        \n\
    }                                                                                                       \n\
    AA[i][j] = ((c < 0) || (c != clz[j])) ? Adead[Adead_base + sc*16*16 + i*16 + j] : 0.0;                  \n\
sum = 0.0;                                                                                                  \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( i == 0 ) {                                                                                         \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            sum += p2[k] * AA[k][j];                                                                        \n\
        p0[j] = sum;                                                                                        \n\
    }                                                                                                       \n\
    sum = 0.0;                                                                                              \n\
barrier(CLK_LOCAL_MEM_FENCE);                                                                               \n\
    if ( 0 == (i+j) ) {                                                                                     \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
        sum += p0[k];                                                                                       \n\
        if ( sum )                                                                                          \n\
            sum = 1.0 / sum;                                                                                \n\
        for (k=Nstate-1; k>=0; --k)                                                                         \n\
            p1[k] = p0[k] * sum;                                                                            \n\
    } else {                                                                                                \n\
        sum = 1.0;                                                                                          \n\
    }                                                                                                       \n\
    ll += log((float)sum);                                                                                  \n\
                                                                                                            \n\
    if ( (i+j) == 0 )                                                                                       \n\
        LL[get_group_id(1)*Nseg + get_group_id(0)] = - ll;                                                  \n\
}                                                                                                           \n\
";


