/* Copyright 2014-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

define("modelsrv", ["express", "body-parser", "compression", "modeldb"], function(express, bodyParser, compression, modeldb) {
    'use strict';
    const exports = express.Router();
    exports.use(bodyParser.json());
    exports.use(bodyParser.urlencoded({ extended: true }));
    
    const db = new modeldb.Connection();

    exports.post("/createLink", (req, res) => {
        db.createLink(""+req.body.signinSecret, req.ip, req.headers['user-agent'],
                     ""+req.body.name, req.body.qmj, ""+req.body.about)
            .then(result => {
                res.json(result);
            })
            .catch(err => { res.json({t: 'Error', msg: err}); });
    });
    exports.post("/loadLink", (req, res) => {
        db.loadLink(req.body.linkId|0, ""+req.body.linkKey)
            .then(result => {
                res.json(result);
            })
            .catch(err => { res.json({t: 'Error', msg: err}); });
    });

    return exports;
});
