/* Copyright 2014-2016 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Express is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Express is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Express program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

const requirejs = require('requirejs');

requirejs.config({
    //Pass the top-level main.js/index.js require
    //function to requirejs so that node modules
    //are loaded relative to the top-level JS file.
    nodeRequire: require,

//    paths: {
//	"qubx": "../js/qubx"
//    },
    
    map: {
	"*": {
	    "jquery" : "jquery_adapter"
	}
    }
});

requirejs(['commander', 'bozos'], function(commander, bozos) {
    commander
	.version('0.0.1')
	.parse(process.argv);

    if ( commander.args.length ) {
        new bozos.Session().remove(commander.args[0])
            .then(() => {
                process.exit();
            }).catch(err => {
                console.log(err);
                process.exit();
            });
    }
});
