/* Copyright 2014-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

define("qubsite", ["express-http-proxy", "qubdl", "qubfaq", "vcheck", "wiki"], function(proxy, qubdl, qubfaq, vcheck, wiki) {
    'use strict';
    
    const exports = {};
    /* allows directory proxy to apache when user omits final slash
    function directoryize(app, dir) {
        app.get('/' + dir, function (req, res, next) {
            if (req.url !== '/' + dir) {
                return next();
            }
            res.redirect('/' + dir + '/');
        });
    }
    */
    exports.setup = (app) => {
        const toDownload = (req, res) => {
            res.redirect('/download/');
        };
        app.use('/win.php', toDownload);
        app.use('/dl.php', toDownload);
        app.use('/dl.cgi', toDownload);
        app.use('/soft.cgi', toDownload);
        app.use('/down.cgi', toDownload);

        app.use('/vcheck.cgi', vcheck);
            
        app.use("/download", qubdl);
        app.use("/faq", qubfaq);
        app.use("/wiki", wiki);
        app.use("/xmeans*", (req, res, next) => {
            res.redirect('/online/xmeans.html');
        });
        app.use('/forum*', (req, res, next) => {
            res.redirect('/faq/');
        });

        //directoryize(app, "wiki");
        //app.use('/wiki', proxy('http://127.0.0.1:8080', {
        //    forwardPath: function(req, res) {
        //        return req.originalUrl;
        //        // return url.parse(req.url).path; // strips the routing prefix
        //    }
        //}));

        //directoryize(app, "forum");
        //app.use('/forum', proxy('http://127.0.0.1:8080', {
        //    forwardPath: function(req, res) {
        //        return req.originalUrl;
        //    }
        //}));

        //directoryize(app, "xmeans");
        //app.use('/xmeans', proxy('http://127.0.0.1:8080', {
        //    forwardPath: function(req, res) {
        //        return req.originalUrl;
        //    }
        //}));

        // for Besch family, probably done by now
        //directoryize(app, "webtrees");
        //app.use('/webtrees', proxy('http://127.0.0.1:8080', {
        //    forwardPath: function(req, res) {
        //        return req.originalUrl;
        //    }
        //}));

        // for gooogogle/index.cgi
        //app.use('/\*.cgi', proxy('http://127.0.0.1:8080', {
        //    forwardPath: function(req, res) {
        //        return req.originalUrl;
        //    }
        //}));

        return app;
    };

    return exports;
});
