// main script for iframe: quboptstat_server/index.html

define("ajaxIframe", ["qubx"], function(qubx) {
    var exports = {};
    var mainWindow = null;
    var mainOrigin = "";
    
    window.addEventListener('message', function (e) {
        mainWindow = e.source;
        mainOrigin = e.origin;
        var s = e.data.serial;
        qubx.postJson(e.data.method, e.data.arg)
            .then(function(data) {
                if ( data.t === 'Error' ) {
                    mainWindow.postMessage({serial: s, t: 'Error', msg: data.msg}, mainOrigin);
                } else {
                    mainWindow.postMessage({serial: s, arg: data}, mainOrigin);
                }
            })
            .catch(function(err) {
                var err = {t: 'Error', msg: err.message, serial: s};
                mainWindow.postMessage(err, mainOrigin);
            });
    });

    parent.postMessage({t: "Init"}, '*');
    
    return exports;
});
