/* Copyright 2014-2016 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Express is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Express is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Express program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

define("models", ["qubx"], function(qubx) {
    "use strict";

    var server = qubx.ws('wss'+window.location.origin.replace(/^https?/, '')+'/online/modeldb');

    var exports = {
        getModelQmj: function(modelId) {
            return server.request({
                t: 'getModelQmj',
                modelId: modelId
            });
        },
        getModelInfo: function(modelId) {
            return server.request({
                t: 'getModelInfo',
                modelId: modelId
            });
        },
        loadLink: function(linkId, linkKey) {
            return server.request({
                t: 'loadLink',
                linkId: linkId,
                linkKey: linkKey
            });
        },
        log: function(obj) {
            return server.request(qubx.extend({}, obj, {t: 'ping'}));
        }
    };

    return exports;
});
