/* Copyright 2014-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

"use strict";

importScripts('qubx_worker_require.js');
//importScripts('qubx_worker_require.min.js');

qubx_require(['qubx_worker_util', 'qubx_xmeans_math']).then(libs => {
    const [util, qubx_xmeans_math] = libs;
    const xmeans = new qubx_xmeans_math.Calc();
    util.listen({
        // trace: true,
        stop: data => close(),
        setData: data => {
            xmeans.columns = data.columns;
            xmeans.weight = data.weight || (xmeans.columns.length && xmeans.columns[0].map(() => 1.0));
            return {};
        },
        getClusters: data => {
            data.clusters = xmeans.TryK(data.k, data.trials, data.iterations);
        },
        iterate: data => {
            data.clusters = xmeans.Iterate(data.k, data.color, data.iterations);
        }
    });
});
