/* Copyright 2016-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

define("wiki", ["express"], function(express) {
    'use strict';

    function rewritePath(path) {
        path = path.substring(1);
        path = path.replace('/','-');
        path = path.replace(':','-');
        let hashLoc = path.indexOf('#');
        if ( hashLoc >= 0 ) {
            path = path.substring(0, hashLoc) + '.html' + path.substring(hashLoc);
        } else {
            path = path + '.html';
        }
        return path;
    }
    
    const router = express.Router();

    router.use('/index.php', (req, res, next) => {
        res.redirect('/wiki/'+rewritePath(req.path));
    });
    router.use('/', express.static('/var/www/wiki'));
    
    // final (default) handler:
    router.use((req, res, next) => { res.redirect('/wiki'); });
    

    return router;
});
